// ChatDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BVtango.h"
#include "ChatDlg.h"
#include "ncs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChatDlg dialog


CChatDlg::CChatDlg(Session *ses, CWnd* pParent /*=NULL*/)
	: CDialog(CChatDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChatDlg)
	//}}AFX_DATA_INIT

	session = ses;
	file = fopen("chat.log", "w");
}

CChatDlg::~CChatDlg()
{
	fclose(file);
}

void CChatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChatDlg)
	DDX_Control(pDX, IDC_ENTER_EDIT, m_EnterEdit);
	DDX_Control(pDX, IDC_SHOW_EDIT, m_ShowEdit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChatDlg, CDialog)
	//{{AFX_MSG_MAP(CChatDlg)
	ON_BN_CLICKED(IDC_ENTER, OnEnter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatDlg message handlers

void CChatDlg::OnEnter() 
{
	Enter();
}


void CChatDlg::Enter()
{
	char text[100];

	m_EnterEdit.GetWindowText(text, 100);
	AddMsg(session->localMember, text);
	m_EnterEdit.SetSel(0, -1);
	m_EnterEdit.Clear();
	ncsSendToApp(6666, TEXT, text, strlen(text)+1);
}

void CChatDlg::AddMsg(int user, char *str)
{
	char *text;
	int len;

	m_ShowEdit.FmtLines(TRUE);
	text = new char[strlen(str) + 22];
	if(user >= 0)
		strcpy(text, session->member[user].user);
	else
		strcpy(text, "local");
	strcat(text, ": ");
	strcat(text, str);
	len = strlen(text);
	text[len] = 13;
	text[len + 1] = 10;
	text[len + 2] = 0;
	m_ShowEdit.SetSel(-1, -1);
	m_ShowEdit.ReplaceSel(text);
	delete text;
}


BOOL CChatDlg::DestroyWindow() 
{
	ShowWindow(SW_HIDE);
	
	return TRUE;
	//return CDialog::DestroyWindow();
}

void CChatDlg::message(int usr, int tag, char *msg, int len)
{
	char *tmp;

	tmp = new char[len + 1];
	memcpy(tmp, msg, len);
	tmp[len] = 0;
	switch(tag)
	{
	case TEXT:
		AddMsg(usr, msg);
		break;
	}
	delete tmp;
}
