//////////////////////////////////////////////////////////////////////////
//
// File					: rgb2yuv.h
//
// Description			: Convertion functions between video formats
//						  -header
//
///////////////////////////////////////////////////////////////////////////

void RGB16toYUV(WORD *input, 
			 unsigned char *y, unsigned char *u, unsigned char *v, 
			 int width, int height);

void RGB24toYUV(unsigned char *input, 
			 unsigned char *y, unsigned char *u, unsigned char *v, 
			 int width, int height);

void YVU9toYUV411(unsigned char *input, 
			 unsigned char *y, unsigned char *u, unsigned char *v, 
			 int width, int heigth);

void resizeYUV9(char *image, int x0, int y0, char *out, int x1, int y1);

void RGB24toQCIF(char *input, int width, int height, char *output);
