// OptionDlg.h : header file
//
#include "BuenaVistaDlg.h"
#include "options.h"

/////////////////////////////////////////////////////////////////////////////
// COptionDlg dialog

class COptionDlg : public CDialog
{
// Construction
public:
	void SetConnection(char *conn);
	COptionDlg(CBuenaVistaDlg *dlg, Options *opt, CWnd* pParent = NULL);   // standard constructor
	CDialog *conndlg;
	CDialog *audiodlg;
	CDialog *videodlg;
	
	Options *options;

	CBuenaVistaDlg *main_dlg;

	// Dialog Data
	//{{AFX_DATA(COptionDlg)
	enum { IDD = IDD_OPTIONS_DLG };
	CTabCtrl	m_OptionTab;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COptionDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(COptionDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeOptionsTab(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnApply();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
